unit ComboBoxLista_ActiveDelphi;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, UtilList, Graphics;

type
  TComboBoxLista_ActiveDelphi = class(TComboBox)
    procedure DoEnter; override;
    procedure DoExit; override;
    public procedure SetIndexByText(text: string);
    public procedure SetIndexByStringKey(string_key: string);
    public procedure SetIndexByIntegerKey(integer_key: Integer);
    public procedure SetIndexByCount(count_key: Integer);
    public function GetSelectedStringKey: string;
    public function GetSelectedIntegerKey: Integer;
    private FUtilList: TUtilList;
    procedure SetUtilList(const Value: TUtilList);
    published property UtilList: TUtilList read FUtilList write SetUtilList;   //Pripriedade que ser utilizada
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ACTIVEDELPHI', [TComboBoxLista_ActiveDelphi]);
end;

{ TComboBoxLista_ActiveDelphi }
procedure TComboBoxLista_ActiveDelphi.DoEnter;
begin
  inherited;
  Color := clInfoBk;
  Font.Style := Font.Style + [fsBold];
end;

procedure TComboBoxLista_ActiveDelphi.DoExit;
begin
  inherited;
  Color := clWhite;
  Font.Style := Font.Style - [fsBold];
end;

function TComboBoxLista_ActiveDelphi.GetSelectedIntegerKey: Integer;
begin
  Result := FUtilList.GetIntegerKey(TComboBoxLista_ActiveDelphi(Self).ItemIndex);
end;

function TComboBoxLista_ActiveDelphi.GetSelectedStringKey: string;
begin
  Result := FUtilList.GetStringKey(TComboBoxLista_ActiveDelphi(Self).ItemIndex);
end;

procedure TComboBoxLista_ActiveDelphi.SetIndexByCount(count_key: Integer);
begin
  TComboBoxLista_ActiveDelphi(Self).ItemIndex:=Items.IndexOf(FUtilList.GetItem(count_key));
end;

procedure TComboBoxLista_ActiveDelphi.SetIndexByIntegerKey(integer_key: Integer);
begin
  TComboBoxLista_ActiveDelphi(Self).ItemIndex:=Items.IndexOf(FUtilList.GetItemByIntegerKey(integer_key));
end;

procedure TComboBoxLista_ActiveDelphi.SetIndexByStringKey(string_key: string);
begin
  TComboBoxLista_ActiveDelphi(Self).ItemIndex:=Items.IndexOf(FUtilList.GetItemByStringKey(string_key));
end;

procedure TComboBoxLista_ActiveDelphi.SetIndexByText(text: string);
begin
  TComboBoxLista_ActiveDelphi(Self).ItemIndex:=Items.IndexOf(text);
end;

procedure TComboBoxLista_ActiveDelphi.SetUtilList(const Value: TUtilList);
var
  i: Integer;
begin
  FUtilList := Value;
  TComboBoxLista_ActiveDelphi(Self).Clear;
  for i := 0 to FUtilList.Count-1 do begin
    TComboBoxLista_ActiveDelphi(Self).Items.Add(FUtilList.GetItem(i));
  end;
  TComboBoxLista_ActiveDelphi(Self).Refresh;
end;

end.
